/******************************************************************************/
/* Mobile Views 1.0 - Mobile View System                                      */
/*                                                                            */
/* Copyright (C) 2002 Elaine Quintino da Silva & Dilvan de Abreu Moreira.     */
/*                                                                            */
/* This library is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU Lesser General Public                 */
/* License as published by the Free Software Foundation; either               */
/* version 2.1 of the License, or (at your option) any later version.         */
/*                                                                            */
/* This library is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          */
/* Lesser General Public License for more details.                            */
/*                                                                            */
/* You should have received a copy of the GNU Lesser General Public           */
/* License along with this library; if not, write to the Free Software        */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */
/*                                                                            */
/* Contact:                                                                   */
/*       Eletronic mail: elainesilva@zipmail.com or dilvan@computer.org       */
/*       Paper mail: Av. trabalahdor So Carlense, 400 Cx. Postal 668,        */
/*                   So Carlos,So Paulo                                     */
/*                   Brasil CEP 13560-970                                     */
/******************************************************************************/

package agents;

import java.awt.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.net.URL;
import java.net.JarURLConnection;

/**
 * Class for loading images from jar file
 */
public class ImageLoader {
    ClassLoader load = null;
    
    /** Method for creation of a new instance from this class.*/
    public ImageLoader() {
        try {
            load = this.getClass().getClassLoader();
        } catch (Exception e) {}
    }
    
    /** Method for loading an image from the file specified by the string s */
    public final ImageIcon loadImageIcon(String s) {
        ImageIcon image = null;
        URL url = load.getResource(s);
        if (url != null) {
            image = new ImageIcon(url);
        } 
        return (image);
    }
    
    /** Method for returning the loaded image.*/
    public final Image loadImage(String s) {
        return (loadImageIcon(s).getImage());
    }
}
