/******************************************************************************/
/* Mobile Views 1.0 - Mobile View System                                      */
/*                                                                            */
/* Copyright (C) 2002 Elaine Quintino da Silva & Dilvan de Abreu Moreira.     */
/*                                                                            */
/* This library is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU Lesser General Public                 */
/* License as published by the Free Software Foundation; either               */
/* version 2.1 of the License, or (at your option) any later version.         */
/*                                                                            */
/* This library is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          */
/* Lesser General Public License for more details.                            */
/*                                                                            */
/* You should have received a copy of the GNU Lesser General Public           */
/* License along with this library; if not, write to the Free Software        */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */
/*                                                                            */
/* Contact:                                                                   */
/*       Eletronic mail: elainesilva@zipmail.com or dilvan@computer.org       */
/*       Paper mail: Av. trabalahdor So Carlense, 400 Cx. Postal 668,        */
/*                   So Carlos,So Paulo                                     */
/*                   Brasil CEP 13560-970                                     */
/******************************************************************************/

package agents.util;

import java.io.*;
import java.util.*;


/** This class implements the FilenameFilter interface.
 * It defines the accept method that defines if a file is listed or not.
 * It considers any regular expression with '*' ou '?' */
public class SimpleFilter extends Object implements FilenameFilter {
    private String pattern;
    public SimpleFilter(String pattern) {
        this.pattern = pattern;
    }
    
    public boolean accept(File dir, String name) {
        if (pattern.equals("*") || pattern.equals("")) return true;
        return match(name, pattern);
    }
    
    public boolean match(String str, String pat) {
        if (pat.equals("")) return str.equals("");
        if (str.equals("")) return pat.equals("*");
        if (str.substring(0,1).equals(pat.substring(0,1)) || pat.substring(0,1).equals("?")) {
            return match(str.substring(1), pat.substring(1));
        }
        if (pat.substring(0,1).equals("*")) {
            for (int i=0; i <= str.length(); i++) {
                if (match(str.substring(i), pat.substring(1))) return true;
            }
        }
        return false;
    }
    
}

