/******************************************************************************/
/* WebCoM 1.0 - Web Course Manager                                            */
/*                                                                            */
/* Copyright (C) 2002 Elaine Quintino da Silva & Dilvan de Abreu Moreira.     */
/*                                                                            */
/* This library is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU Lesser General Public                 */
/* License as published by the Free Software Foundation; either               */
/* version 2.1 of the License, or (at your option) any later version.         */
/*                                                                            */
/* This library is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          */
/* Lesser General Public License for more details.                            */
/*                                                                            */
/* You should have received a copy of the GNU Lesser General Public           */
/* License along with this library; if not, write to the Free Software        */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */
/*                                                                            */
/* Contact:                                                                   */
/*       Eletronic mail: elainesilva@zipmail.com or dilvan@computer.org       */
/*       Paper mail: Av. trabalahdor So Carlense, 400 Cx. Postal 668,        */
/*                   So Carlos,So Paulo                                     */
/*                   Brasil CEP 13560-970                                     */
/******************************************************************************/

package course.classes;

import java.awt.*;
import java.io.*;
import java.awt.event.*;
import java.sql.*;
import java.util.*;

import agents.View;
import agents.SQL;
import agents.ErrorWindow;
import course.create.*;
import agents.security.Ticket;
import agents.agent.Defaults;
import course.util.UtilFunctions;

/** Class for creation of new test. */
public class TestView implements View, Serializable{
    transient TestPanel testsPanel;
    transient Panel p1;
    
    String resource;
    DataActivities dataActivities;
    int idClass;
    int idTest = 0;
    Ticket tic;
    
    /** Method for setting variables.*/
    public void setVariable(int idClass){
        this.idClass = idClass;
    }
    
    /** Method for creation of new instance from the View class. The next test id will be the last +1.*/
    public Object createView(Ticket tic, SQL sql) throws Exception {
        this.resource = tic.resource;
        this.tic = tic;
        
        dataActivities = new DataActivities();
        sql.init(this.resource);
        ResultSet rs = sql.executeQuery("SELECT expire FROM class WHERE id='" + idClass + "'");
        rs.next();
        dataActivities.expireClass = UtilFunctions.deconvertDate(rs.getString(1));
        rs = sql.executeQuery("SELECT id FROM tests WHERE class='" + idClass + "' ORDER BY id DESC");
        if (rs.next()) {
            int id = rs.getInt(1);
            idTest = id;
        } else
            idTest = 0;
        dataActivities.numberTests = idTest;
        dataActivities.indexTests = idTest;
        dataActivities.idClass = idClass;
        sql.close();
        return this;
    }
    
    /** Method for creation of a graphic interface for this class.*/
    public Panel initView() {
        Panel principal = new Panel();
        principal.setLayout(new FlowLayout());
        principal.setFont(new Font("Helvetica", Font.PLAIN, 12));
        
        testsPanel = new TestPanel();
        p1 = testsPanel.initView();
        testsPanel.atualizeView(dataActivities);
        principal.add(p1);
        return principal;
    }
    
    /** Method for validation of graphic interface information. */
    public boolean validateView() {
        ErrorWindow er = null;
        int errorView = testsPanel.validateView(dataActivities);
        if (errorView != 0) {
            if (errorView == 1)
                er = new ErrorWindow("Invalid Information.");
            if (errorView == 2)
                er = new ErrorWindow("The test date is after the class's expire date.");
            if (errorView == 3)
                er = new ErrorWindow("The test delivery date should be orderer.");
            if (errorView == 4)
                er = new ErrorWindow("The weight should be bigger than 0.");
            er.show();
            return false;
        }
        dataActivities = testsPanel.update(dataActivities);
        dataActivities.indexTests--; // it have to do the same position because there is only one test o insert
        return true;
    }
    
    /** Method for management of the database information about the test.*/
    public synchronized Object updateView(SQL sql) throws Exception {
        String instruction = null;
        
        sql.init(resource);
        // insert the data about the new test in the database
        ResultSet rs = sql.executeQuery("SELECT username FROM students WHERE class='" + idClass + "'");
        for (;rs.next();) {
            sql.executeUpdate("INSERT INTO activities VALUES('" + rs.getString(1) + "','tests'," +
            dataActivities.test[dataActivities.indexTests].id + ",'',0,'" + idClass + "')");
        }
        
        instruction = new String("INSERT INTO tests VALUES (" +
        dataActivities.test[dataActivities.indexTests].id + ",'" +
        UtilFunctions.convertDate(dataActivities.test[dataActivities.indexTests].deliveryDate) + "','" +
        dataActivities.test[dataActivities.indexTests].weight + "','" +
        dataActivities.idClass + "')");
        sql.executeUpdate(instruction);
        sql.close();
        EditClassSelection editClassSelection = new EditClassSelection();
        editClassSelection.setVariable("Class "+ idClass);
        return editClassSelection.createView(tic,sql);
    }
}
