<!--
/******************************************************************************************************************/
/* WebCoM 1.0 - Web Course Manager                                                                                */
/*                                                                                                                */ 
/* Copyright (C) 2002 Elaine Quintino da Silva & Dilvan de Abreu Moreira. All rights reserved.                    */   
/*                                                                                                                */   
/* WebCoM is free software; you can redistribute it and/or modify it under the terms of the GNU General           */
/* Public License as published by the Free Software Foundation; either version 2 of the License, or any later     */
/* version.                                                                                                       */
/*                                                                                                                */
/* WebCoM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the           */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License    */
/* for more details.                                                                                              */
/*                                                                                                                */
/* You should have received a copy of the GNU General Public License along with this program; if not, write to    */
/* the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.                   */
/*                                                                                                                */
/* Contact:                                                                                                       */
/*       Eletronic mail: elainesilva@zipmail.com or dilvan@computer.org                                           */
/*       Paper mail: Av. trabalahdor So Carlense, 400 Cx. Postal 668, So Carlos,So Paulo - Brasil CEP 13560-970*/                                                                                 
/******************************************************************************************************************/
-->

<HTML>
<HEAD>
  <TITLE>Add Candidate</TITLE>
  <META NAME="Author" CONTENT="Dilvan de Abreu Moreira">
</HEAD>

<SCRIPT>
   function error(elem, text) {
      window.alert(text);
      elem.select();
      elem.focus(); 
   }

   function hasNumber(text) {
      return (text.indexOf('0', 0) != -1 ||
          text.indexOf('1', 0) != -1 ||
          text.indexOf('2', 0) != -1 ||
          text.indexOf('3', 0) != -1 ||
          text.indexOf('4', 0) != -1 ||
          text.indexOf('5', 0) != -1 ||
          text.indexOf('6', 0) != -1 ||
          text.indexOf('7', 0) != -1 ||
          text.indexOf('8', 0) != -1 ||
          text.indexOf('9', 0) != -1);
   }

   function validateUsername(elem) { 
      carac = 'a';
      for (cont=0; cont < elem.value.length; cont++) {
           carac= elem.value.charAt(cont);
           if ((carac<'a' || carac>'z' ) && (carac <'A' || carac>'Z') && (carac<'0' || carac>'9') && (carac!='_' && carac!='-')) {
               error(elem, "Invalid character for the Username");
               return false;
           }
     }

     if (elem.value.length == 0) {
          error(elem, "Missing Username");
          return false;
     }

     if ((elem.value.length < 5) || (elem.value.length > 16)) {
          error(elem, "The Username should be bigger 5 or smaller 16 characters");
          return false;
     }
     elem.value = elem.value.toLowerCase();
     return true;
   }

   function validateID(elem) { 
      carac = 'a';
      for (cont=0; cont < elem.value.length; cont++) {
           carac= elem.value.charAt(cont);
           if ((carac<'a' || carac>'z' ) && (carac <'A' || carac>'Z') && (carac<'0' || carac>'9') && (carac!='_' && carac!='-')) {
               error(elem, "Invalid character for the idNumber");
               return false;
           }
     }
     if (elem.value.length > 16) {
          error(elem, "The id number should be smaller 16 characters");
          return false;
     }
     return true;
   }

   function validateName(elem) { 
      if (elem.value.indexOf(' ', 0) == -1 && !hasNumber(elem.value) &&  elem.value.length != 0)
         return true;
      error(elem, elem.name + " should be just one word (no numbers or spaces).");
      elem.value=""; 
      return false;
   }

   function validateLastName(elem) { 
      if (validateName(elem)){
         return true;
      }
      return false;
   }

   function validateNumber(elem) {
      carac = 'a';
      for (cont=0; cont < elem.value.length; cont++) {
           carac= elem.value.charAt(cont);
           if (carac<'0' || carac>'9') {
               error(elem, "Invalid character for the idNumber");
               return false;
           }
     }
     return true;
   } 

   function validateEmail(elem) { 
      if (elem.value.length==0) {
         error(elem, elem.name + ": you must have an e-mail to be a participant.");
         return false;
      }
      if (elem.value.indexOf(' ', 0) == -1 &&
          elem.value.indexOf('@', 0) != -1 &&
          elem.value.length != 0) {
         return true;
      }
      error(elem, elem.name + ": format wrong.");
      elem.value=""; 
      return false;
   }

   function validateURL(elem) {
      if (elem.value.length==0) return true;
      if (elem.value.substring(0, 5) == "http:") return true;
      if (elem.value.length <= 58) {
         elem.value= "http://" + elem.value;
         return true;
      }
      error(elem, elem.name + ": URL too big.");
      elem.value="";
      return false; 
   }

   // main validate function
   function Validate() {
      if (!validateUsername(document.form.username)) return false;
      if (!validateID(document.form.id)) return false;
      if (!validateLastName(document.form.last_name)) return false;
      if (!validateName(document.form.first_name)) return false;
      if (!validateEmail(document.form.email)) return false;
      if (!validateURL(document.form.homepage)) return false;
      if (!validateNumber(document.form.study_time)) return false;
      window.open("","result","width=400,height=350");
      return true;
   }

</SCRIPT>

<BODY TEXT="#000000" background="gifs/fundo2.gif">
<FONT FACE="Arial" SIZE="3"><B>Add Candidates</B></FONT>
<HR>
<%@ page import="java.io.*" %>
<%  String database = request.getParameter("database"); %>
<FORM NAME=form METHOD=POST TARGET="result"
      ACTION="/manager_files/read_candidate.jsp?database=<%=database%>" 
      OnSubmit="return Validate();">
  <table width="100%" border="0">
    <tr>
      <td width="7%">&nbsp;</td>
      <td width="93%"> 
        <b><font face="Arial" color="#000000"><u>Please note this 
          information:</u></font></b>
        <ul>
          <li> <font size="2">Don't send the form if you can't commit the time 
            and effort to complete the course.</font> </li>
          <li> <font size="2">A selection of candidates will be made. If you was 
            accepted, you will receive a confirmation message.</font> </li>
          <li> <font size="2">If you drop the course, you may be requested to 
            answer a form about the problems you had.</font> </li>
          <li> <font size="2">The button <b>Add Me</b> will submit your form to 
            the course database.</font> </li>
          <li><font color="#0000FF"><i><font size="2">* You can fill in the blue field only if you have an Identification 
            number.</font></i></font> </li>
          <li> <font size="2" color="#FF0000"><i>* You must to fill in the red fields.</i></font></li>
          <br>
        </ul> 
        <!--<P>If you want to change any of your data latter: submit the form again
keeping the same last_name and email, this will delete your data, then
come back to this page to fill the form again.-->
        <b> 
        <font face="Arial,Helvetica" color="#000000"><u>Please fill in your 
          personal information:</u></font>
        </b>
		<br><br>
        <table border=0 width="100%" >
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font face="Arial" size="2" color="#FF0000">Username: 
                </font></b></div>
            </td>
            <td> 
              <input name="username" type=text size=16 maxlength=16 
onChange="validateUsername(document.form.username);" >
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font face="Arial" color="#0000FF" size="2">Identification 
                Number:</font></b></div>
            </td>
            <td> 
              <input type="text" name="id" size="16" maxlength="16" onChange="validateID(document.form.id);" >
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font size="2" face="Arial" color="#FF0000">First 
                name:</font></b></div>
            </td>
            <td> 
              <input name="first_name" type=text size=32 maxlength=32
onChange="validateName(document.form.first_name);" >
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font size="2" face="Arial" color="#FF0000">Last 
                name:</font></b></div>
            </td>
            <td> 
              <input name="last_name" type=text size=32 maxlength=32 
onChange="validateLastName(document.form.last_name);" >
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><font face="Arial" size="2"><b>Middle names:</b></font> 
              </div>
            </td>
            <td> 
              <input name="middle_names" type=text size=32 maxlength=32>
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font size="2" face="Arial"> Address: </font></b></div>
            </td>
            <td> 
              <input name="address" type=text size=64 maxlength=64>
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font size="2" face="Arial"> Zip Code: </font></b></div>
            </td>
            <td> 
              <input name="zip_code" type=text size=16 maxlength=16>
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font size="2" face="Arial"> City: </font></b></div>
            </td>
            <td> 
              <input name="city" type=text size=16 maxlength=16>
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font size="2" face="Arial"> State: </font></b></div>
            </td>
            <td> 
              <input name="state" type=text size=16 maxlength=16>
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font size="2" face="Arial"> Country: </font></b></div>
            </td>
            <td> 
              <input name="country" type=text size=16 maxlength=16>
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font size="2" face="Arial"> Phone: </font></b></div>
            </td>
            <td> 
              <input name="phone" type=text size=16 maxlength=16>
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font size="2" face="Arial" color="#FF0000">E-mail: 
                </font></b></div>
            </td>
            <td> 
              <input name="email" type=text size=32 maxlength=32
onChange="validateEmail(document.form.email);">
            </td>
          </tr>
          <tr> 
            <td align=right width="20%"> 
              <div align="left"><b><font size="2" face="Arial"> HomePage: </font></b></div>
            </td>
            <td> 
              <input name="homepage" type=text size=64 maxlength=64
onChange="validateURL(document.form.homepage);">
            </td>
          </tr>
        </table>
		<br>
          <b><font face="Arial,Helvetica" color="#000000"><u>Please fill in your 
          profile form:</u></font></b>
		  <br><br>
        <table border=0 width="100%">
          <tr> 
            <td align=right width="41%"> 
              <div align="left"><b><font size="2" face="Arial" color="#000000">Where 
                do you work?</font></b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%"> 
              <div align="left"><b> 
                <select name="where_work">
                  <option value=""> 
                  <option value=multnational>Multinational Company 
                  <option value=private>Private Company 
                  <option value=public>State Owned Company 
                  <option value=consultant>Consultant 
                  <option value=university>University or College 
                  <option value=school>High or Elementary School 
                  <option value=government>Government 
                  <option value=student>Student 
                  <option value=unemployed>Unemployed 
                  <option value=other>Other 
                </select>
                </b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%" > 
              <div align="left"><b><font size="2" face="Arial" color="#000000">Name 
                of the place where you work:</font></b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%" > 
              <div align="left"><b> 
                <input name="work_name" type=text size=32 maxlength=32>
                </b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%" > 
              <div align="left"><b><font size="2" face="Arial" color="#000000">Work 
                Address:</font></b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%" > 
              <div align="left"><b> 
                <input name="work_address" type=text size=64 maxlength=64>
                </b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%"> 
              <div align="left"><b><font size="2" face="Arial" color="#000000">What 
                is your Education level?</font></b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%"> 
              <div align="left"><b> 
                <select name="school_level">
                  <option value=""> 
                  <option value=dr>Doctor 
                  <option value=master>Master 
                  <option value=university>University 
                  <option value=high>High school (2 grau) 
                  <option value=elementary>Elementary School (1 grau) 
                </select>
                </b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%"> 
              <div align="left"><b><font size="2" face="Arial" color="#000000">What 
                is your English level?</font></b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%"> 
              <div align="left"><b> 
                <select name="english_level">
                  <option value=""> 
                  <option value=native>Near native speaker 
                  <option value=conversation>Conversation 
                  <option value=general>General (read and write) 
                  <option value=technical>Technical (read manuals) 
                </select>
                </b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%" > 
              <div align="left"><b><font size="2" face="Arial" color="#000000">What 
                is your Computer skills?</font></b> </div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%" > 
              <div align="left"> 
                <select name="comp_level">
                  <option value=""> 
                  <option value=expert>Expert: AI, Motif, CORBA, Xwindows, OORDB, 
                  etc. 
                  <option value=advanced>Advanced: LISP, OOP, SQL, Unix, etc. 
                  <option value=intermediary>Intermediary: C, C++, Windows NT. 
                  <option value=basic>Basic: Visual Basic, Windows 95, Delphi, 
                  etc. 
                </select>
              </div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%" > 
              <div align="left"><b><font size="2" face="Arial" color="#000000">What 
                is your language (Java or C) skills?</font></b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%" > 
              <div align="left"><b> 
                <select name="java_level">
                  <option value=""> 
                  <option value=c>Work C and C++ programming
                  <option value=oop>Work with OOP (C++, Delphi, etc)
                  <option value=java>Work with applets
                  <option value=javaAdv>Work with Java advanced resources
                  <option value=none>None 
                </select>
                </b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%">
              <div align="left"><b><font size="2" face="Arial" color="#000000">For 
                what would you use programming languages for (mainly)?</font></b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%"> 
              <div align="left"><b> 
                <select name="java_use">
                  <option value=""> 
                  <option value=applications>Stand alone applications 
                  <option value=legacy>Access to legacy software 
                  <option value=sql>Access to SQL Databases 
                  <option value=applets>Clients using applets 
                  <option value=teach>Teaching 
                  <option value=none>No specific use 
                </select>
                </b></div>
            </td>
          </tr>
          <tr> 
            <td align=right width="41%"> 
              <div align="left"><b><font size="2" face="Arial">How 
                many hours per week can you dedicate to the course?</font></b> 
                <input name="study_time" type=text size=2 maxlength=2 value=0
onChange="validateNumber(document.form.study_time);">
              </div>
            </td>
          </tr>
        </table>
      </td>
  </tr>
</table> 
<br>
<br>
    <center> 
    <input type=submit value="   Add me   " name="submit">
    <input type=reset value=" Clear Form " name="reset">
    <input type=button value="    Exit    " onClick="window.close()" name="button">
	</center>
</FORM>
</BODY>
</HTML>
